LPARAM lcType,lcPath
* lcType - Distribution type
*   N - Normal; EXE binary, without debug info
*   D - Debug;, EXE binary, with debug info
*   S - Source; Source code (programs, free tables ), project and additional programs
*   H - HTML documentation
* lcPath - Output folder

IF EMPTY(lcType) OR EMPTY(lcPath)
   RETURN
ENDIF

DECLARE INTEGER RemoveDirectory IN kernel32 String @lpszPath
DECLARE INTEGER DeleteFile      IN kernel32 String @lpszFile
DECLARE INTEGER CopyFile IN KERNEL32 STRING @lpExistingFileName, STRING @lpNewFileName, INTEGER
DECLARE INTEGER SetLastError IN kernel32 Integer fdwError
DECLARE INTEGER GetDriveType IN kernel32 String lpszRootPathName



lcPath=AddBackSlashInPath(ALLT(lcPath))

* Pokud neexistuje  clov cesta, pak ji zalo
IF !DIRECTORY(lcPath)
   =Mkd(lcPath)
ELSE
   * jinak ji vyisti
   =RemoveDirectoryAll(lcPath,.F.)
ENDIF


* Podle typu se rozhodhi
* N - Normal, bez zdrojovch kdu a debug informac
* D - Debug, bez zdrojovch kdu
* S - Source, zdrojov kdy + projekt bez EXE
* H - HTML dokumentace

* F1 - pdm.fll source
* F2 - string.fll source

IF lcType="N"
   =CNormal(lcPath)
ELSE
   IF lcType="D"
      =CDebug(lcPath)
   ELSE
      IF lcType="S"
         =CSource(lcPath)
      ELSE
         IF lcType="H"
            =CHTML(lcPath)
         ELSE
            IF lcType="F1"
               =CPDMFLL(lcPath)
            ELSE
               IF lcType="F2"
                  =CSTRINGFLL(lcPath)
               ELSE
               ENDIF
            ENDIF
         ENDIF
      ENDIF
   ENDIF
ENDIF

******************************************************************************
* Normln distribuce
******************************************************************************
PROCEDURE CNormal(lcPath)
* lcPath - Clov cesta

* pdm.exe bez debug info
* pdm.fll
* string.fll
* lang/.
* gui/.
* plug-in/.
* res/.
* test/.

LOCAL lcAlias,lcMainPath
lcAlias=SYS(2015)
lcMainPath=GetMainPath()

USE pdm.pjx IN 0 ALIAS (lcAlias)
SELE (lcAlias)
LOCATE FOR TYPE="H"
REPLACE DEBUG WITH .F. NEXT 1
USE
KEYB "{A}" PLAIN
BUILD EXE (lcMainPath+"pdm.exe") FROM (lcMainPath+"pdm.pjx")

=CopyFile((lcMainPath+"pdm.exe"),(lcPath+"pdm.exe"),0)
=CopyFile((lcMainPath+"pdm.fll"),(lcPath+"pdm.fll"),0)
=CopyFile((lcMainPath+"pdm.ini"),(lcPath+"pdm.ini"),0)
=CopyFile((lcMainPath+"config.fpw"),(lcPath+"config.fpw"),0)
=CopyFile((lcMainPath+"string.fll"),(lcPath+"string.fll"),0)
=CopyFile((lcMainPath+"license.txt"),(lcPath+"license.txt"),0)
=CopyDirectory(lcMainPath+"lang",lcPath+"lang",.T.,.T.)
=CopyDirectory(lcMainPath+"plug-in",lcPath+"plug-in",.T.,.T.)
DELE FILE (lcPath+"plug-in\*.h")
DELE FILE (lcPath+"plug-in\*.prg")


COMPILE CLASSLIB (lcMainPath+"gui\pdm.vcx")

=CopyDirectory(lcMainPath+"gui",lcPath+"gui",.T.,.T.)
DELE FILE (lcPath+"gui\pdm.h")

USE (lcPath+"gui\pdm.vcx") IN 0 ALIAS (lcAlias) EXCL
SELE (lcAlias)
REPLACE METHODS WITH "" ALL
PACK MEMO
PACK
USE

=CopyDirectory(lcMainPath+"res",lcPath+"res",.T.,.T.)
=CopyDirectory(lcMainPath+"test",lcPath+"test",.T.,.T.)

******************************************************************************
* Debug distribuce
******************************************************************************
PROCEDURE CDebug(lcPath)
* lcPath - Clov cesta

* pdm.exe s debug info
* pdm.fll
* string.fll
* lang/.
* gui/.
* plug-in/.
* res/.
* test/.

LOCAL lcAlias,lcMainPath
lcAlias=SYS(2015)
lcMainPath=GetMainPath()

USE pdm.pjx IN 0 ALIAS (lcAlias)
SELE (lcAlias)
LOCATE FOR TYPE="H"
REPLACE DEBUG WITH .T. NEXT 1
USE
KEYB "{A}" PLAIN
BUILD EXE (lcMainPath+"pdm.exe") FROM (lcMainPath+"pdm.pjx")

=CopyFile((lcMainPath+"pdm.exe"),(lcPath+"pdm.exe"),0)
=CopyFile((lcMainPath+"pdm.fll"),(lcPath+"pdm.fll"),0)
=CopyFile((lcMainPath+"config.fpw"),(lcPath+"config.fpw"),0)
=CopyFile((lcMainPath+"pdm.ini"),(lcPath+"pdm.ini"),0)
=CopyFile((lcMainPath+"string.fll"),(lcPath+"string.fll"),0)
=CopyFile((lcMainPath+"license.txt"),(lcPath+"license.txt"),0)
=CopyDirectory(lcMainPath+"lang",lcPath+"lang",.T.,.T.)

COMPILE CLASSLIB (lcMainPath+"gui\pdm.vcx")
=CopyDirectory(lcMainPath+"gui",lcPath+"gui",.T.,.T.)
=CopyDirectory(lcMainPath+"plug-in",lcPath+"plug-in",.T.,.T.)
DELE FILE (lcPath+"plug-in\*.h")

=CopyDirectory(lcMainPath+"res",lcPath+"res",.T.,.T.)
=CopyDirectory(lcMainPath+"test",lcPath+"test",.T.,.T.)


******************************************************************************
* Source distribuce
******************************************************************************
PROCEDURE CSource(lcPath)
* lcPath - Clov cesta

* pdm.pjx/pdm.pjt
* pdm.fll
* string.fll
* vcxs/.
* lang/.
* plug-in/.
* res/.
* gui/.
* test/.
* dbfs/.
* prgs/.
* doc/.

LOCAL lcMainPath
lcMainPath=GetMainPath()


=CopyFile((lcMainPath+"pdm.pjx"),(lcPath+"pdm.pjx"),0)
=CopyFile((lcMainPath+"pdm.pjt"),(lcPath+"pdm.pjt"),0)
=CopyFile((lcMainPath+"pdm.fll"),(lcPath+"pdm.fll"),0)
=CopyFile((lcMainPath+"pdm.ini"),(lcPath+"pdm.ini"),0)
=CopyFile((lcMainPath+"config.fpw"),(lcPath+"config.fpw"),0)
=CopyFile((lcMainPath+"string.fll"),(lcPath+"string.fll"),0)
=CopyFile((lcMainPath+"comments.txt"),(lcPath+"comments.txt"),0)
=CopyFile((lcMainPath+"synstring.prg"),(lcPath+"synstring.prg"),0)
=CopyFile((lcMainPath+"changestring.prg"),(lcPath+"changestring.prg"),0)
=CopyFile((lcMainPath+"cdistr.prg"),(lcPath+"cdistr.prg"),0)
=CopyFile((lcMainPath+"license.txt"),(lcPath+"license.txt"),0)
=CopyFile((lcMainPath+"setsenv.prg"),(lcPath+"setsenv.prg"),0)

=CopyDirectory(lcMainPath+"lang",lcPath+"lang",.T.,.T.)
=CopyDirectory(lcMainPath+"gui",lcPath+"gui",.T.,.T.)
=CopyDirectory(lcMainPath+"plug-in",lcPath+"plug-in",.T.,.T.)


=CopyDirectory(lcMainPath+"res",lcPath+"res",.T.,.T.)
=CopyDirectory(lcMainPath+"test",lcPath+"test",.T.,.T.)
=CopyDirectory(lcMainPath+"dbfs",lcPath+"dbfs",.T.,.T.)
=CopyDirectory(lcMainPath+"prgs",lcPath+"prgs",.T.,.T.)

=CopyFile((lcMainPath+"Readme.htm"),(lcPath+"Readme.htm"),0)
=CopyDirectory(lcMainPath+"doc",lcPath+"doc",.T.,.T.)


******************************************************************************
* Dokumentace
******************************************************************************
PROCEDURE CHTML(lcPath)
* lcPath - Clov cesta

* doc/.

LOCAL lcMainPath
lcMainPath=GetMainPath()
=CopyFile((lcMainPath+"Readme.htm"),(lcPath+"Readme.htm"),0)
=CopyDirectory(lcMainPath+"doc",lcPath+"doc",.T.,.T.)

******************************************************************************
* pdm.fll - source code
******************************************************************************
PROCEDURE CPDMFLL(lcPath)
LOCAL lcMainPath
lcMainPath="d:\x_disc\project\pdm\pdm0100\"
=CopyFile((lcMainPath+"Pdm0100.cpp"),(lcPath+"Pdm0100.cpp"),0)
=CopyFile((lcMainPath+"Pdm0100.dsp"),(lcPath+"Pdm0100.dsp"),0)
=CopyFile((lcMainPath+"Pdm0100.rc"),(lcPath+"Pdm0100.rc"),0)
=CopyFile((lcMainPath+"resource.h"),(lcPath+"resource.h"),0)

******************************************************************************
* string.fll - source code
******************************************************************************
PROCEDURE CSTRINGFLL(lcPath)
LOCAL lcMainPath
lcMainPath="d:\x_disc\project\pdm\string0100\"
=CopyFile((lcMainPath+"string0100.cpp"),(lcPath+"string0100.cpp"),0)
=CopyFile((lcMainPath+"string0100.dsp"),(lcPath+"string0100.dsp"),0)
=CopyFile((lcMainPath+"string0100.rc"),(lcPath+"string0100.rc"),0)
=CopyFile((lcMainPath+"resource.h"),(lcPath+"resource.h"),0)


******************************************************************************
* Vrt cestu, kde se nachz program
******************************************************************************
PROCEDURE GetMainPath()
LOCAL lcMainPath
lcMainPath=SYS(16,PROGRAM(-1)-2)
RETURN IIF(RAT("\",lcMainPath)>0,LEFT(lcMainPath,RAT("\",lcMainPath)),lcMainPath)
ENDPROC


******************************************************************************
* Pid backslash k cest, pokud nen
******************************************************************************
PROCEDURE AddBackSlashInPath(lcPath)
* lcPath - cesta
RETURN IIF(EMPTY(lcPath),lcPath,lcPath+IIF(RIGHT(lcPath,1)#"\","\",""))
ENDPROC



******************************************************************************
* Zkopruje obsah adrese do jinho adrese
******************************************************************************
PROCEDURE CopyDirectory(lcSource,lcDest,llChild,llLower)
* lcSource - Zdrojov adres
* lcDest   - Clov adres
* llChild  - Pznak, koprovn podadres
* llLower  - Pznak, zda se maj nzvy adres a soubor pevst na mal psmena
IF PCOUNT()=2 && pokud nen tet parametr
   llChild=.T. && pak nastav pznak koprovn Child Adres
ENDIF
LOCAL lcSourceN,lcDestN,lic,lierr,lierrx,lii,loDir,lcFSource,lcFDest
LOCAL ARRAY laDir(1)

lcSource=ALLT("&lcSource") && preventivn odstra makra
lcDest=ALLT("&lcDest") && preventivn odstra makra

lcSourceN=lcSource+CHR(0) && piti nulov znak
lcDestN=lcDest+CHR(0) && piti nulov znak

IF RIGHT(lcSource,1)#'\' && pokud na konci nen lomtko
   lcSource=lcSource+'\' && pak ho pidej
ENDIF

IF RIGHT(lcDest,1)#'\' && pokud na konci nen lomtko
   lcDest=lcDest+'\' && pak ho pidej
ENDIF

IF ! INLIST(MKD(IIF(llLower,LOWER(lcDest),lcDest)),0,1) && pokud se vytvoen adrese nepoda
   RETURN .F. && pak se vra
ENDIF

lic=ADIR(laDir,lcSource+'*.*','AHRSD')
* pokud nco naet, pak to zpracuj
FOR lii=1 TO lic
    IF !(!laDir(lii,1)=="." AND !laDir(lii,1)=="..") && pokud se jedn o fiktivn adrese
       LOOP && pak sko na dal
    ENDIF
    IF RIGHT(laDir(lii,5),1)='D' && jde o adres a m se koprovat
       * pokud se m koprovat a nejde vytvoit
       IF llChild AND !CopyDirectory(lcSource+laDir(lii,1),lcDest+laDir(lii,1),llChild,llLower)
          RETURN .F. && pak se vra
       ENDIF
    ELSE
       * jinak jde o soubor
       lcFSource=lcSource+laDir(lii,1)+CHR(0) && zdroj
       lcFDest=lcDest+IIF(llLower,LOWER(laDir(lii,1)),laDir(lii,1))+CHR(0) && cl
        =SetLastError(0) && vynuluj chyby
       lierr=CopyFile(@lcFSource,@lcFDest,0) && kopie souboru
       IF lierr=0 && pokud dolo k chyb
          RETURN .F. && pak se vra
       ENDIF
   ENDIF
NEXT
RETURN .T.
ENDPROC


******************************************************************************
* Zalo adres
******************************************************************************
PROCEDURE Mkd(lcPath)
* lcPath -  cesta
LOCAL lcPom,lcDriveRoot,lii,lcErr,liErr

lcPath=ALLT("&lcPath") && preventivn odstra makra

IF DIRECTORY(lcPath) && pokud dan cesta existuje
   RETURN 1 && pak se vra 
ENDIF

* patrn nejde o UNC nebo DOS cestu s diskem
IF !(LEFT(lcPath,2)="\\" OR SUBS(lcPath,2,1)=":")
   lcPom=ALLTRIM(SET("PATH")) && vra nastaven PATH a oe mezery
   IF LEFT(lcPath,1)="\" && jde o cestu z rootu, pak musm pidat jen disk (server+sdlen disk)
      IF LEFT(lcPom,2)="\\" && jde o UNC cestu
         lii=AT("\",lcPom,4) && najdi 4. oddlova
         IF lii>0 && pokud tam je
            lcPom=LEFT(lcPom,lii-1) && pak nati cestu bez oddlovae
         ENDIF
       ELSE
         * jinak jde o DOS cestu
         lcPom=LEFT(lcPom,2)
       ENDIF
   ELSE
      IF RIGHT(lcPom,1)#"\" && pokud na konci nen oddlova
         lcPom=lcPom+"\" && pak ho tam pidej
      ENDIF
   ENDIF
   lcPath=lcPom+lcPath && seti novou cestu
ENDIF

IF LEFT(lcPath,2)#"\\" && pokud to je DOS cesta
   lcDriveRoot=LEFT(lcPath,2)+"\" && vem si disk
   IF INLIST(GetDriveType(lcDriveRoot),0,5) && Disk neexistuje, nebo je to CD-ROM
      RETURN 4  && vra se
   ENDIF
ENDIF

lcErr=ON("ERROR")
liErr=0
ON ERROR liErr=ERROR()
MD (lcPath) && zalo cestu
IF !EMPTY(lcErr)
   ON ERROR &lcErr.
ELSE
   ON ERROR
ENDIF

* pokud nen chyba, pak vra 0
* pstup zamtnut
* invalid path or name
RETURN IIF(liErr=0,0,;
      IIF(liErr=1705,2,;
      IIF(liErr=202,3,3)))  && vra pznak chyb
ENDPROC


******************************************************************************
* Smae obsah adrese
******************************************************************************
PROCEDURE RemoveDirectoryAll(lcSource,llDMain)
IF PCOUNT()<2 && pokud nen parametr
   llDMain=.T.
   IF PCOUNT()=0 && pokud nen parametr
      RETURN .F. && ErrFewArguments pak se vra
   ENDIF
ENDIF
LOCAL lcSourceN,lic,lierr,lierrx,lii,lcFSource
LOCAL ARRAY laDir(1)

lcSource=ALLT("&lcSource") && preventivn odstra makra
lcSourceN=lcSource+CHR(0) && piti nulov znak

IF RIGHT(lcSource,1)#'\' && pokud na konci nen lomtko
   lcSource=lcSource+'\' && pak ho pidej
ENDIF

lic=ADIR(laDir,lcSource+'*.*','AHRSD')
FOR lii=1 TO lic
    IF !(!laDir(lii,1)=="." AND !laDir(lii,1)=="..") && pokud se jedn o fiktivn adrese
       LOOP && pak sko na dal
    ENDIF
    IF RIGHT(laDir(lii,5),1)='D' && jde o adres a m se koprovat
       * pokud se m koprovat a nejde vytvoit
       IF ! RemoveDirectoryAll(lcSource+laDir(lii,1))
          RETURN .F. && ErrOther pak se vra
       ENDIF
    ELSE
       * jinak jde o soubor
       lcFSource=lcSource+laDir(lii,1)+CHR(0) && zdroj
        =SetLastError(0) && vynuluj chyby
       lierr=DeleteFile(@lcFSource) && vmaz souboru
       IF lierr=0 && pokud dolo k chyb
          RETURN .F. && ErrOther pak se vra
       ENDIF
   ENDIF
NEXT
IF llDMain
   =SetLastError(0) && vynuluj chyby
   liErr=RemoveDirectory(lcSourceN) && odstra adres
ELSE
   liErr=0
ENDIF
